<template>
  <header class="header container"
          :class="{
            'header--main': isMainPage && !isMobile,
            'header--dark': (isMainPage && isMobile) || isDarkMobileHeader,
          }">

    <button v-if="!isMenuOpen"
            class="header__burger"
            type="button"
            @click="openMenu">
      <icon-menu-burger />
    </button>

    <nuxt-link to="/"
               class="header__logo"
               :class="isMenuOpen ? 'header__logo--opened' : ''">
      <Logo />
    </nuxt-link>

    <nav class="header__nav" :class="isMenuOpen ? 'header__nav--opened' : ''">
      <button class="header__close-menu"
              type="button"
              @click="closeMenu"></button>

      <ul class="header__menu">
        <li v-for="menuItem in menuItems" :key="menuItem.name"
            class="header__menu-item" :class="menuItem.isBtn ? 'header__menu-item--btn' : ''">

          <nuxt-link v-if="menuItem.isBtn"
                     :to="menuItem.link"
                     class="button"
                     :class="isMainPage && !isMobile ? 'button--transparent' : 'button--gray'">
            {{menuItem.name}}
          </nuxt-link>

          <nuxt-link v-else
                     :to="menuItem.link"
                     class="header__menu-link">
            {{menuItem.name}}
          </nuxt-link>

        </li>
        <li class="header__menu-item">
          <lk-btn :isMainPage="isMainPage" />
        </li>
      </ul>
    </nav>
  </header>
</template>

<script>
  import Logo from '../components/Logo';
  import LkBtn from '../components/LkBtn';
  import IconMenuBurger from './icons/IconMenuBurger';

  export default {
    name: 'Header',
    components: {
      IconMenuBurger,
      Logo,
      LkBtn
    },
    data: () => ({
      menuItems: [
        { name: 'Помещения', link: '/places' },
        { name: 'Правила', link: '/rules' },
        { name: 'О нас', link: '/about' },
        { name: 'Отзывы', link: '/reviews' },
        { name: 'Контакты', link: '/contacts' },
        { name: 'Партнёрам', link: '/partners', isBtn: true },
      ],
      isMenuOpen: false,
      isDarkMobileHeader: false,
    }),
    computed: {
      isMainPage() {
        return this.$route.fullPath === '/';
      },

      isMobile() {
        return this.$store.state.isMobile;
      }
    },
    mounted() {
      this.checkMobileTopOffset();
      window.addEventListener('scroll', () => this.checkMobileTopOffset());

      document.addEventListener('click', (e) => {
        const path = e.path || (event.composedPath && event.composedPath());

        if (!path) return;

        const headerEl = path.filter((pathItem) => {
          if (typeof pathItem.classList === 'undefined') return false;
          return pathItem.classList.contains('header');
        })[0];

        if (!this.isMobile || !this.isMenuOpen) return;
        if (headerEl) return;

        this.closeMenu();
      })
    },
    methods: {
      openMenu() {
        this.isMenuOpen = true;
      },

      closeMenu() {
        this.isMenuOpen = false;
      },

      checkMobileTopOffset() {
        if (!this.isMobile) return;

        this.isDarkMobileHeader = window.pageYOffset > 20;
      }
    },
    watch:{
      $route (){
        this.closeMenu();
      },

      isMobile(val) {
        if (val) {
          this.checkMobileTopOffset();
        }
      }
    }

  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .header {
    position: relative;
    z-index: 5;

    display: flex;
    align-items: center;
    justify-content: space-between;

    padding-top: rem(30);
    padding-bottom: rem(40);

    &--main {
      .header {
        &__menu-link {
          color: $white;
        }

        &__logo svg {
          fill: $white;

          max-width: 100%;
          max-height: 100%;
        }
      }
    }

    @media (max-width: $mobile-width) {
      position: fixed;
      top: 0;

      width: 100%;
      height: rem(65);
      padding: rem(25) 0 rem(20);

      justify-content: center;

      background: rgba($black, 0);
      transition: background .5s;

      &--dark {
        background: rgba($black, .4);

        .header__burger {
          svg {
            fill: $white;
          }
        }

        .header__logo {
          svg {
            fill: $white;
          }
        }
      }

    }

    &__logo {
      width: rem(160);
      height: rem(20);

      svg {
        fill: $blue;
      }

      @media (max-width: $mobile-width) {
        transition: transform .5s;

        &--opened {
          transition: transform .5s;
          transform: translateX(calc(14.25rem / 2));
        }

      }
    }

    &__menu {
      display: flex;

      @media (max-width: $mobile-width) {
        flex-flow: column;
        flex: 1 1;

        margin-top: rem(30);
      }
    }

    &__menu-item {
      display: flex;
      align-items: center;

      &--btn {
        margin: 0 rem(18);

        @media (max-width: $mobile-width) {
          margin: 0;
          margin-left: rem(40);
        }
      }

      @media (max-width: $mobile-width) {
        & + & {
          margin-top: rem(28);
        }
      }
    }

    &__menu-link {
      @include bold-black-link;
      @include main-link;

      padding: 0 rem(18);

      &.nuxt-link-active {
        color: $green;
      }

      @media (max-width: $mobile-width) {
        padding: 0;
        padding-left: rem(40);

        font-size: rem(18);
      }
    }

    &__burger {
      display: none;

      position: absolute;
      top: 50%;
      left: rem(12);
      transform: translateY(-50%);

      width: rem(40);
      height: rem(40);

      background: transparent;
      border: none;

      svg {
        fill: $blue;
      }

      @media (max-width: $mobile-width) {
        display: block;
      }
    }

    &__close-menu {
      display: none;

      width: rem(52);
      height: rem(52);

      background: url('/images/icon-close-menu.svg') center no-repeat;
      background-size: contain;
      border: none;

      @media (max-width: $mobile-width) {
        display: block;
      }
    }

    &__nav {
      @media (max-width: $mobile-width) {
        position: absolute;
        left: 0;
        top: 0;
        bottom: 0;

        display: flex;
        flex-flow: column;

        height: 100vh;
        width: rem(228);
        padding: rem(6) rem(4) rem(28);

        background: $white;
        border-radius: 0 0 .5rem 0;

        transform: translateX(-100%);
        transition: transform .5s;

        &--opened {
          transform: translateX(0);
        }
      }

    }
  }
</style>
